/* MC-patches.h: header file for baysian fitting the patch occupancy model of
   metapopulation dynamics  : Metropolis-Hasiting per year and Gibbs  per patch
   C.J.F. ter Braak, CBW, Wageningen
   c.j.f.terbraak@plant.wag-ur.nl
   January, 2001*/


#ifndef _MC_PATCHES_H

#define _MC_PATCHES_H


#include <stdio.h>
#include <stdlib.h>

typedef int   state_t;     /* state of patch is 0/1 (int)  */

#if QUICK == 2 || QUICK == 3

double MC_patches(long nsubiter, int nyear, int npatch, \
 state_t **Xs, int Xs_tot[], int L, int StartPattern, int **ti_missinglist, double **S, double **ADa,\
 double *logA, double **logE1_E, double **ptheta, int npar, double **X, int *nxpar, double **logtrprob,\
 double *pEloglik,double *pE2loglik, int startyear, int endyear,
 int propose_t, int propose_t1, double *accept_p, double **pab);

#if QUICK == 2
double propose_column(int npatch,
   state_t x1[], state_t x1p[], state_t x2[], 
	 double logtrprobx0_x1[], double logtrprobx1_x2[],
	 double logtrprobx0_x1p[], double logprobx1p_x2[],
   double S1[], double S1p[], double** ADa, double logA[], double** logE1_E, \
   double theta2[], int npar, double** X, int *nxpar, double Jxp[]);

double propose_column_data(int npatch, state_t x1[], state_t x1p[], state_t x2[],
	 double logtrprobx0_x1[], double logtrprobx1_x2[],
	 double logtrprobx0_x1p[],  double logprobx1p_x2[],
   double S1[], double S1p[], double** ADa, double logA[], double** logE1_E, \
   double theta2[], int npar, double** X, int *nxpar,
	 int *ibeginmissing, int **ti_missinglist, int stot_1, double Jxp[]);
#endif /*QUICK == 2*/

void  Gibbs_one_patch(int npatch, state_t x1[], state_t x1p[], state_t x2[],
	 double logtrprobx0_x1[], double **logtrprobx1_x2,
	 double **logprobx1p_x2,
   double **S1, double **S1p, double logA[], double** logE1_E, double** ADa, \
   double theta2[], int npar, double** X, int *nxpar,
	 int *ibeginmissing, int **ti_missinglist);

void Gibbs_column_last_t(state_t x1[], state_t x1p[],
	 double logtrprobx0_x1[],	 
	 int *ibeginmissing, int **ti_missinglist, int stot_1);

void calc_logtrprob(int npatch, int startyear, int endyear, state_t **Xs, \
	double **S, double *logA, double** logE1_E, double **theta, int npar, double **X, int *nxpar, double **logtrprob);

double floglik0(int npatch, int startyear, int endyear, double **logtrprob);

void init_Xs_S2(int nyear, int npatch, int **idata, int **ti_missinglist, int nmissing, \
 state_t **Xs,  int Xs_tot[], int L, int StartPattern, double **S, double **ADa,\
 double *logA, double** logE1_E, double **theta_ini, int npar, double **X, int *nxpar, double f_ini,
 int propose_t, double** logtrprob);

double logptrans(state_t x1i, state_t x0i, double S0, double logA, double logE1_Ei[], 
              double theta0[], int npar, double X[], int *nxpar);
void ftrans_theta2(double *theta, double *trans_theta, int npar, double *trans_par);
void fbacktrans_theta2(double *theta, double *trans_theta, int npar, double *trans_par);
void fbacktrans_ptheta2(double **ptheta, double **trans_ptheta, int npar, double *trans_par);


 
#endif /*QUICK == 2 || QUICK == 3*/

void	myfwrite(FILE *out, long iter, int lag, double loglik0, double logprior0, double **theta0, double **trans_theta0, int npar, double accept_p);
void	myfwrite2(FILE *out, long iter, int lag, state_t **Xs, int **ti_missinglist, int nyear, int indexnyear);

void calc_S2(double *S, int npatch, state_t *Xs, double **ADa);
void read_Dist(FILE *dis, int npatch, double **D, double **B);
void calc_ADa(double **ADa, int npatch, double *A, double **D, double **B, double alpha, double b, int With_area_effect);

#if QUICK == 3
double propose_column0(int npatch, state_t x0[],
   state_t x1[], state_t x1p[], state_t x2[], 
   double logtrprobx0_x1[], double logtrprobx1_x2[],
   double logtrprobx0_x1p[], double logprobx1p_x2[],
   double S0[], double S1p[], double** ADa, double logA[], double **logE1_E, \
   double theta2[], int npar, double** X, int *nxpar, double J[]);

double propose_column0_data(int npatch, state_t x0[],
         state_t x1[], state_t x1p[], state_t x2[],
	 double logtrprobx0_x1[], double logtrprobx1_x2[],
	 double logtrprobx0_x1p[],  double logprobx1p_x2[],
   double S0[], double S1p[], double** ADa, double logA[], double** logE1_E, \
   double theta2[], int npar, double** X, int *nxpar,
	 int *ibeginmissing, int **ti_missinglist, int stot_1, double J[]);
#endif /*QUICK == 3*/


#endif /* _MC_PATCHES_H */

